//+------------------------------------------------------------------+
//|                                                          TTF.mq4 |
//|                                                                  |
//| Trend Trigger Factor by M. H Pee                                 |
//| Made according to TASC 12/2004 by Linuxser                       |
//| http://www.traders.com/Documentation/FEEDbk_docs/Archive/122004  |
//|     /TradersTips/TradersTips.html#investor                       |
//| Linuxser 2007                                                    |
//|                                                                  |
//|                                         http://www.forextsd.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_level1 100
#property indicator_level2 -100
#property indicator_level3 0
//---- input parameters
extern int TTFPeriod=14;
//---- buffers
double TTFBuffer[];
double HighestHighRecent=0,
       HighestHighOlder=0,
       LowestLowRecent=0, 
       LowestLowOlder=0;
double BuyPower=0, 
       SellPower=0, 
       TTF=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,TTFBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="TTF_Lnx("+TTFPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,TTFPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=TTFPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=TTFPeriod;i++) TTFBuffer[Bars-i]=0.0;
//----
   i=Bars-TTFPeriod-1;
   if(counted_bars>=TTFPeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {
      HighestHighRecent = High[Highest(Symbol(),0,MODE_HIGH,TTFPeriod,i)];
      HighestHighOlder = High[Highest(Symbol(),0,MODE_HIGH,TTFPeriod,i + TTFPeriod)];
      LowestLowRecent = Low [Lowest(Symbol(),0,MODE_LOW,TTFPeriod,i)];
      LowestLowOlder = Low [Lowest(Symbol(),0,MODE_LOW,TTFPeriod,i+TTFPeriod)];
      BuyPower = HighestHighRecent - LowestLowOlder;
      SellPower = HighestHighOlder - LowestLowRecent;
      TTF = (BuyPower - SellPower) / (0.5 * (BuyPower + SellPower)) * 100;   
      TTFBuffer[i]=TTF; 
      i--;
     }
   return(0);
  }
//+------------------------------------------------------------------+